Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1089425 - Review Request: keepass - Password manager
Summary: Review Request: keepass - Password manager
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: David King
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 751719 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-04-18 22:44 UTC by Peter Oliver
Modified: 2014-06-15 01:53 UTC (History)
5 users (show)

Fixed In Version: keepass-2.26-8.fc19
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-06-01 22:21:53 UTC
amigadave: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Peter Oliver 2014-04-18 22:44:20 UTC
Spec URL: http://mavit.fedorapeople.org/rpm/keepass.spec
SRPM URL: http://mavit.fedorapeople.org/rpm/keepass-2.26-1.fc20.src.rpm
Description: KeePass is a free open source password manager, which helps you to
manage your passwords in a secure way. You can put all your passwords in
one database, which is locked with one master key or a key file.  You
only have to remember one single master password or select the key file
to unlock the whole database.
Fedora Account System Username: mavit

Comment 1 Peter Oliver 2014-04-18 23:19:31 UTC
*** Bug 751719 has been marked as a duplicate of this bug. ***

Comment 2 Peter Oliver 2014-04-20 14:45:36 UTC
Updated package:

Spec URL: http://mavit.fedorapeople.org/rpm/keepass.spec
SRPM URL: http://mavit.fedorapeople.org/rpm/keepass-2.26-2.fc20.src.rpm

Comment 3 David King 2014-05-06 15:13:03 UTC
Works fine, just some packaging guideline fixes required.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs a %{name}.desktop using desktop-file-install or desktop-
  file-validate if there is such a file.

It seems that this is a requirement, and pretty easy to fix: https://fedoraproject.org/wiki/Packaging:Guidelines#desktop-file-install_usage

- License file not installed when -doc subpackage is installed

I do not know which license the documentation would be under, but my guess would be (implicitly) the same as the rest of the package. I suggest including License.txt in the -doc subpackage. https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Subpackage_Licensing

- Calls rm -rf %{buildroot} and mkdir %{buildroot} at the start of %install.

Is there a reason to do this? It looks like it just duplicates what RPM does, according the the build log, and upsets fedora-review. Related to https://fedoraproject.org/wiki/Packaging:Guidelines#BuildRoot_tag

- The -doc subpackage does not own /usr/share/doc/keepass

I suppose that the -doc subpackage should own the directory, in addition to the keepass package. https://fedoraproject.org/wiki/Packaging:Guidelines#The_directory_is_owned_by_a_package_which_is_not_required_for_your_package_to_function

- Icon theme directory ownership

Similar to the -doc subpackage ownership, the keepass package should own the icon directories.

Optional issues:

- Preserve modification time of installed files. Adding "-p" to install and cp arguments should help.

- The -doc subpackage should be noarch, as there is nothing architecture-specific there. Also, it would be nice to move the %package for the subpackage closer to the top of the file.

- Incorrect line-endings in -doc subpackage. I suppose that the same sed as for the .txt files would be appropriate.

Bogus issues:

- The rpmlint errors are all bogus and can be ignored.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later) (with incorrect FSF address)", "GPL (v2 or later)",
     "Unknown or generated". 73 files have unknown license. Detailed output of
     licensecheck in
     /home/david/checkout/rpms/1089425-keepass/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/doc/keepass
[!]: Package must own all directories that it creates.
     Note: Directories without known owners:
     /usr/share/icons/hicolor/256x256/apps, /usr/share/mime/packages,
     /usr/share/mime, /usr/share/doc/keepass,
     /usr/share/icons/hicolor/256x256, /usr/share/icons/hicolor
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: update-desktop-database is invoked in %post and %postun if package
     contains desktop file(s) with a MimeType: entry.
     Note: desktop file(s) with MimeType entry in keepass
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in keepass
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 143360 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in keepass-doc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed files.
[x]: update-mime-database is invoked in %post and %postun if package stores
     mime configuration in /usr/share/mime/packages.
     Note: mimeinfo files in: keepass
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Arch-ed rpms have a total of 1341440 bytes in /usr/share
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: keepass-2.26-2.fc21.x86_64.rpm
          keepass-doc-2.26-2.fc21.x86_64.rpm
          keepass-2.26-2.fc21.src.rpm
keepass.x86_64: E: no-binary
keepass.x86_64: W: only-non-binary-in-usr-lib
keepass-doc.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/keepass/Chm/KeePass.hhp
keepass-doc.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/keepass/Chm/KeePassContents.hhc
keepass-doc.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/keepass/Chm/default.css
keepass.src:52: E: hardcoded-library-path in %{_prefix}/lib/%{name}
keepass.src:53: E: hardcoded-library-path in %{_prefix}/lib/%{name}
keepass.src:70: E: hardcoded-library-path in %{_prefix}/lib/%{name}
keepass.src: W: patch-not-applied Patch0: keepass-desktop-integration.patch
keepass.src: W: patch-not-applied Patch1: keepass-fix-XSL-search-path.patch
keepass.src: W: patch-not-applied Patch2: keepass-enable-local-help.patch
keepass.src: W: patch-not-applied Patch3: keepass-appdata.patch
keepass.src: W: invalid-url Source0: keepass-2.26.tar.xz
3 packages and 0 specfiles checked; 4 errors, 9 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint keepass-doc keepass
keepass-doc.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/keepass/Chm/KeePass.hhp
keepass-doc.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/keepass/Chm/KeePassContents.hhc
keepass-doc.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/keepass/Chm/default.css
keepass.x86_64: E: no-binary
keepass.x86_64: W: only-non-binary-in-usr-lib
2 packages and 0 specfiles checked; 1 errors, 4 warnings.
# echo 'rpmlint-done:'



Requires
--------
keepass-doc (rpmlib, GLIBC filtered):

keepass (rpmlib, GLIBC filtered):
    /bin/sh
    mono(System)
    mono(System.Drawing)
    mono(System.Security)
    mono(System.Windows.Forms)
    mono(System.Xml)
    mono(mscorlib)
    xdotool



Provides
--------
keepass-doc:
    keepass-doc
    keepass-doc(x86-64)

keepass:
    appdata()
    appdata(keepass.appdata.xml)
    application()
    application(keepass.desktop)
    keepass
    keepass(x86-64)
    mimehandler(application/x-keepass2)
    mono(KeePass)



Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1089425
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 4 Peter Oliver 2014-05-18 19:40:41 UTC
Spec URL: http://mavit.fedorapeople.org/rpm/keepass.spec
SRPM URL: http://mavit.fedorapeople.org/rpm/keepass-2.26-4.fc19.src.rpm

- The licence is included in the file /usr/share/doc/keepass/Chm/help/v2/license.html, which, to my reading, covers the requirement in
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Subpackage_Licensing.

- Since the documentation files with DOS line-endings are HTML files that will be read by a browser, and since browsers can cope fine with DOS line-endings, it doesn't seem worth the additional complexity of converting them, to me.

The other issues I've fixed.  Thanks for the review!

Comment 5 David King 2014-05-18 21:34:25 UTC
Looks good now! Thanks for the clarification about the license, I missed that it was included in the -doc subpackage.

Comment 6 Peter Oliver 2014-05-20 19:17:47 UTC
New Package SCM Request
=======================
Package Name: keepass
Short Description: Password manager
Upstream URL: http://keepass.info/
Owners: mavit
Branches: f19 f20
InitialCC:

Comment 7 Christopher Meng 2014-05-21 01:20:12 UTC
How could this get approved?

1. python -c 'import archmod.CHM; archmod.CHM.CHMDir("Docs").process_templates("Docs/Chm")'


At least you need to use python macro %{__python2}.

2. %files -n %{name}-doc

Why not use "%files doc" directly?

3. %{_mandir}/man1/%{name}.1.gz

You should list it as:

%{_mandir}/man1/%{name}.1*

4. %{_datadir}/mime
%{_datadir}/icons/hicolor

Completely wrong, please add requires on hicolor-icon-theme.

Comment 8 Gwyn Ciesla 2014-05-21 10:08:37 UTC
Git done (by process-git-requests).

Comment 9 Peter Oliver 2014-05-22 19:40:41 UTC
(In reply to Christopher Meng from comment #7)
> How could this get approved?

This sounds like it might be intended to be an insult, aimed at the packager and/or the reviewer.  Please try to avoid discouraging contributions.

> 1. python -c 'import archmod.CHM;
> archmod.CHM.CHMDir("Docs").process_templates("Docs/Chm")'
> 
> At least you need to use python macro %{__python2}.
> 
> 2. %files -n %{name}-doc
> 
> Why not use "%files doc" directly?
> 
> 3. %{_mandir}/man1/%{name}.1.gz
> 
> You should list it as:
> 
> %{_mandir}/man1/%{name}.1*

Fixed all these.  Thanks for picking up on them.

> 4. %{_datadir}/mime
> %{_datadir}/icons/hicolor
> 
> Completely wrong, please add requires on hicolor-icon-theme.

Well that would have been my instinct until I read https://fedoraproject.org/wiki/Packaging:Guidelines#The_directory_is_owned_by_a_package_which_is_not_required_for_your_package_to_function, but, fancy that, hicolor-icon-theme contains only directories, not icons.  Thanks again.

Comment 10 Christopher Meng 2014-05-22 23:57:09 UTC
shared-mime-info owns %{_datadir}/mime.

Comment 11 Peter Oliver 2014-05-23 18:18:19 UTC
(In reply to Christopher Meng from comment #10)
> shared-mime-info owns %{_datadir}/mime.

This one really is contradicted by the packaging guidelines.  See https://fedoraproject.org/wiki/Packaging:ScriptletSnippets#mimeinfo and https://fedoraproject.org/wiki/Packaging:Guidelines#The_directory_is_owned_by_a_package_which_is_not_required_for_your_package_to_function.

Comment 12 Fedora Update System 2014-05-23 19:30:03 UTC
keepass-2.26-8.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/keepass-2.26-8.fc19

Comment 13 Fedora Update System 2014-05-23 19:30:50 UTC
keepass-2.26-8.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/keepass-2.26-8.fc20

Comment 14 Fedora Update System 2014-05-24 23:28:40 UTC
keepass-2.26-8.fc19 has been pushed to the Fedora 19 testing repository.

Comment 15 Fedora Update System 2014-06-01 22:21:53 UTC
keepass-2.26-8.fc20 has been pushed to the Fedora 20 stable repository.

Comment 16 Fedora Update System 2014-06-15 01:53:13 UTC
keepass-2.26-8.fc19 has been pushed to the Fedora 19 stable repository.


Note You need to log in before you can comment on or make changes to this bug.